<?php

namespace App\Livewire\Studio\Loyalty;

use App\Livewire\Forms\Studio\Loyalty\CustomerForm;
use App\Models\Customer as CustomerModel;
use App\Traits\WithAuthorization;
use App\Traits\WithCloseModal;
use App\Traits\WithConfirmation;
use App\Traits\WithToast;
use App\Traits\WithUpdatedData;
use Flux\Flux;
use Livewire\Attributes\On;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Customer')]
class Customer extends Component
{
    use WithAuthorization, WithCloseModal, WithConfirmation, WithToast, WithUpdatedData;

    public CustomerForm $form;

    public string $method = 'create';

    public string $modalTitle = '';

    #[On('modal:open')]
    public function openModal(string $method, string $modalTitle, ?string $id = null)
    {
        $this->resetValidation();
        $this->resetErrorBag();

        $this->method = $method;
        $this->modalTitle = $modalTitle;

        if ($id) {
            $this->form->setCustomer(CustomerModel::byHashOrFail($id));
        }
    }

    public function create()
    {
        $this->canOrAbort('create customer');

        $this->form->store();

        $this->dispatch('refreshDatatable');

        $this->toast('Customer berhasil ditambahkan.');

        Flux::modals()->close();
    }

    public function update()
    {
        $this->canOrAbort('update customer');

        $this->form->update();

        $this->dispatch('refreshDatatable');

        $this->toast('Customer berhasil diperbarui.');

        Flux::modals()->close();
    }

    public function delete(CustomerModel $customer)
    {
        $customer->delete();

        $this->dispatch('refreshDatatable');

        $this->toast('Customer berhasil dihapus.');

        Flux::modals()->close();
    }

    public function render()
    {
        return view('livewire.studio.loyalty.customers', [
            'pageTitle' => 'Customer',
        ]);
    }
}
